UIPackage
Menu

Framework

Change language

Boilerplate repo

Progress Linear

progress-linearui

Top-of-screen page-loading bar (à la NProgress / nuxt loading-indicator). Auto-advances while a navigation or fetch is in flight, then completes. Drop into the app shell once.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/progress-linear.json
Named registry:npx shadcn-vue@latest add @uipkge/progress-linearInstalls to:app/components/ui/progress-linear/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
classHTMLAttributes['class']optional
modelValuenumber0optional
bgColorstringoptional
buffernumberoptional
color
'default''primary''secondary''destructive''success''warning''info''error'
defaultoptional
heightnumber | stringoptional
indeterminatebooleanfalseoptional
reversebooleanfalseoptional
rounded
'none''sm''default''md''lg''xl''full'
optional
streambooleanfalseoptional
stripedbooleanfalseoptional
activebooleantrueoptional

npm dependencies

Files installed (3)

  • app/components/ui/progress-linear/ProgressLinear.vue5.5 kB
    <script setup lang="ts">
    import { computed } from 'vue'
    import type { HTMLAttributes } from 'vue'
    import { cn } from '@/lib/utils'
    import { progressLinearVariants } from './progress-linear.variants'
    
    const props = withDefaults(
      defineProps<{
        class?: HTMLAttributes['class']
        modelValue?: number
        bgColor?: string
        buffer?: number
        color?: string
        height?: number | string
        indeterminate?: boolean
        reverse?: boolean
        rounded?: 'none' | 'sm' | 'default' | 'md' | 'lg' | 'xl' | 'full'
        stream?: boolean
        striped?: boolean
        active?: boolean
      }>(),
      {
        modelValue: 0,
        indeterminate: false,
        reverse: false,
        stream: false,
        striped: false,
        active: true,
      },
    )
    
    const normalizedValue = computed(() => {
      return Math.min(100, Math.max(0, props.modelValue))
    })
    
    const normalizedBuffer = computed(() => {
      return Math.min(100, Math.max(0, props.buffer || 0))
    })
    
    const heightValue = computed(() => {
      if (typeof props.height === 'number') return `${props.height}px`
      if (typeof props.height === 'string') return props.height
      return '4px'
    })
    
    const bgColorValue = computed(() => props.bgColor || 'currentColor')
    
    const progressColorValue = computed(() => props.color || 'currentColor')
    
    const containerClasses = computed(() => cn(progressLinearVariants({ rounded: props.rounded }), props.class))
    </script>
    
    <template>
      <div
        data-uipkge
        data-slot="progress-linear"
        role="progressbar"
        :aria-valuemin="0"
        :aria-valuemax="100"
        :aria-valuenow="indeterminate ? undefined : normalizedValue"
        :class="containerClasses"
        :style="{ height: heightValue }"
      >
        <!-- Background -->
        <div
          class="absolute inset-0 transition-colors duration-300"
          :class="[
            striped ? 'progress-striped-light' : '',
            !indeterminate && normalizedBuffer > 0 ? 'opacity-30' : 'opacity-100',
          ]"
          :style="{
            backgroundColor: bgColorValue,
            width: normalizedBuffer > 0 ? `${normalizedBuffer}%` : '100%',
          }"
        />
    
        <!-- Buffer (if buffer > 0) -->
        <div
          v-if="!indeterminate && normalizedBuffer > 0 && normalizedBuffer < 100"
          class="absolute inset-0 transition-colors duration-300"
          :class="[reverse ? 'right-0 left-auto' : 'right-auto left-0', striped ? 'progress-striped-medium' : '']"
          :style="{
            backgroundColor: bgColorValue,
            width: `${normalizedBuffer}%`,
            opacity: 0.3,
          }"
        />
    
        <!-- Stream lines (when stream is true) -->
        <div
          v-if="stream && !indeterminate && active"
          class="absolute inset-0 overflow-hidden"
          :class="reverse ? 'right-0 left-auto' : 'right-auto left-0'"
        >
          <div class="animate-stream progress-stream absolute inset-0" :style="{ width: `${normalizedBuffer || 100}%` }" />
        </div>
    
        <!-- Progress bar -->
        <div
          class="absolute inset-y-0 transition-colors duration-300"
          :class="[
            reverse ? 'right-0 left-auto' : 'right-auto left-0',
            indeterminate ? 'motion-safe:animate-indeterminate' : '',
            striped && !indeterminate ? 'progress-striped-heavy' : '',
          ]"
          :style="{
            width: indeterminate ? '100%' : `${normalizedValue}%`,
            backgroundColor: indeterminate ? undefined : progressColorValue,
          }"
        >
          <!-- Indeterminate animations -->
          <template v-if="indeterminate">
            <div
              class="motion-safe:animate-indeterminate1 absolute inset-y-0 w-full bg-inherit"
              :style="{ backgroundColor: progressColorValue }"
            />
            <div
              class="motion-safe:animate-indeterminate2 absolute inset-y-0 w-full bg-inherit"
              :style="{ backgroundColor: progressColorValue }"
            />
          </template>
        </div>
      </div>
    </template>
    
    <style scoped>
    /* Gradient utilities */
    .progress-striped-light {
      background-image: repeating-linear-gradient(
        45deg,
        transparent,
        transparent 8px,
        rgba(255, 255, 255, 0.1) 8px,
        rgba(255, 255, 255, 0.1) 16px
      );
    }
    
    .progress-striped-medium {
      background-image: repeating-linear-gradient(
        45deg,
        transparent,
        transparent 8px,
        rgba(255, 255, 255, 0.15) 8px,
        rgba(255, 255, 255, 0.15) 16px
      );
    }
    
    .progress-striped-heavy {
      background-image: repeating-linear-gradient(
        45deg,
        transparent,
        transparent 8px,
        rgba(255, 255, 255, 0.25) 8px,
        rgba(255, 255, 255, 0.25) 16px
      );
    }
    
    .progress-stream {
      background-image: repeating-linear-gradient(
        90deg,
        transparent,
        transparent 10px,
        rgba(255, 255, 255, 0.2) 10px,
        rgba(255, 255, 255, 0.2) 20px
      );
      background-size: 40px 40px;
    }
    
    @media (prefers-reduced-motion: no-preference) {
      .animate-indeterminate {
        animation: indeterminate 2s cubic-bezier(0.4, 0, 0.6, 1) infinite;
      }
    
      .animate-indeterminate1 {
        animation: indeterminate1 2s cubic-bezier(0.4, 0, 0.6, 1) infinite;
      }
    
      .animate-indeterminate2 {
        animation: indeterminate2 2s cubic-bezier(0.4, 0, 0.6, 1) infinite;
      }
    
      .animate-stream {
        animation: stream 1s linear infinite;
      }
    }
    
    @keyframes indeterminate {
      0% {
        transform: translateX(-100%);
      }
      100% {
        transform: translateX(400%);
      }
    }
    
    @keyframes indeterminate1 {
      0% {
        transform: translateX(-100%);
      }
      100% {
        transform: translateX(400%);
      }
    }
    
    @keyframes indeterminate2 {
      0% {
        transform: translateX(-100%);
        opacity: 1;
      }
      100% {
        transform: translateX(400%);
        opacity: 0;
      }
    }
    
    @keyframes stream {
      0% {
        transform: translateX(0);
      }
      100% {
        transform: translateX(40px);
      }
    }
    </style>
    
  • app/components/ui/progress-linear/progress-linear.variants.ts1.1 kB
  • app/components/ui/progress-linear/index.ts0.3 kB

Raw manifest:https://uipkge.dev/r/vue/progress-linear.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Progress Linear

progress-linearui

Top-of-screen page-loading bar (à la NProgress / nuxt loading-indicator). Auto-advances while a navigation or fetch is in flight, then completes. Drop into the app shell once.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/progress-linear.json
Named registry:npx shadcn@latest add @uipkge-react/progress-linearInstalls to:components/ui/progress-linear/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
rounded
'none''sm''default''md''lg''xl''full'
defaultoptional
color
'default''primary''secondary''destructive''success''warning''info''error'
defaultoptional
classNamestringoptional
valuenumberoptional
bgColorstringoptional
buffernumberoptional
heightnumber | stringoptional
indeterminatebooleanoptional
reversebooleanoptional
streambooleanoptional
stripedbooleanoptional
activebooleanoptional

npm dependencies

Files installed (3)

  • components/ui/progress-linear/ProgressLinear.tsx5.5 kB
    import * as React from 'react'
    import { cn } from '@/lib/utils'
    import { progressLinearVariants, type ProgressLinearVariants } from './progress-linear.variants'
    
    export interface ProgressLinearProps {
      className?: string
      value?: number
      bgColor?: string
      buffer?: number
      color?: string
      height?: number | string
      indeterminate?: boolean
      reverse?: boolean
      rounded?: ProgressLinearVariants['rounded']
      stream?: boolean
      striped?: boolean
      active?: boolean
    }
    
    // Keyframes are scoped in the Vue SFC via <style scoped>; React has no
    // scoped styles, so we inline the same keyframes + animation utilities once.
    // The class names (animate-indeterminate*, animate-stream) are referenced
    // from the markup below and match the Vue source 1:1.
    const styles = `
    @media (prefers-reduced-motion: no-preference) {
      .uipkge-pl .animate-indeterminate {
        animation: uipkge-pl-indeterminate 2s cubic-bezier(0.4, 0, 0.6, 1) infinite;
      }
      .uipkge-pl .animate-indeterminate1 {
        animation: uipkge-pl-indeterminate1 2s cubic-bezier(0.4, 0, 0.6, 1) infinite;
      }
      .uipkge-pl .animate-indeterminate2 {
        animation: uipkge-pl-indeterminate2 2s cubic-bezier(0.4, 0, 0.6, 1) infinite;
      }
      .uipkge-pl .animate-stream {
        animation: uipkge-pl-stream 1s linear infinite;
      }
    }
    @keyframes uipkge-pl-indeterminate {
      0% { transform: translateX(-100%); }
      100% { transform: translateX(400%); }
    }
    @keyframes uipkge-pl-indeterminate1 {
      0% { transform: translateX(-100%); }
      100% { transform: translateX(400%); }
    }
    @keyframes uipkge-pl-indeterminate2 {
      0% { transform: translateX(-100%); opacity: 1; }
      100% { transform: translateX(400%); opacity: 0; }
    }
    @keyframes uipkge-pl-stream {
      0% { transform: translateX(0); }
      100% { transform: translateX(40px); }
    }
    `
    
    function ProgressLinear({
      className,
      value = 0,
      bgColor,
      buffer,
      color,
      height,
      indeterminate = false,
      reverse = false,
      rounded,
      stream = false,
      striped = false,
      active = true,
    }: ProgressLinearProps) {
      const normalizedValue = Math.min(100, Math.max(0, value))
      const normalizedBuffer = Math.min(100, Math.max(0, buffer || 0))
    
      const heightValue = typeof height === 'number' ? `${height}px` : typeof height === 'string' ? height : '4px'
    
      const bgColorValue = bgColor || 'currentColor'
      const progressColorValue = color || 'currentColor'
    
      const containerClasses = cn('uipkge-pl', progressLinearVariants({ rounded }), className)
    
      return (
        <div
          data-uipkge=""
          data-slot="progress-linear"
          role="progressbar"
          aria-valuemin={0}
          aria-valuemax={100}
          aria-valuenow={indeterminate ? undefined : normalizedValue}
          className={containerClasses}
          style={{ height: heightValue }}
        >
          <style>{styles}</style>
    
          {/* Background */}
          <div
            className={cn(
              'absolute inset-0 transition-colors duration-300',
              striped
                ? 'bg-[repeating-linear-gradient(45deg,transparent,transparent_8px,rgba(255,255,255,0.1)_8px,rgba(255,255,255,0.1)_16px)]'
                : '',
              !indeterminate && normalizedBuffer > 0 ? 'opacity-30' : 'opacity-100',
            )}
            style={{
              backgroundColor: bgColorValue,
              width: normalizedBuffer > 0 ? `${normalizedBuffer}%` : '100%',
            }}
          />
    
          {/* Buffer (if buffer > 0) */}
          {!indeterminate && normalizedBuffer > 0 && normalizedBuffer < 100 && (
            <div
              className={cn(
                'absolute inset-0 transition-colors duration-300',
                reverse ? 'right-0 left-auto' : 'right-auto left-0',
                striped
                  ? 'bg-[repeating-linear-gradient(45deg,transparent,transparent_8px,rgba(255,255,255,0.15)_8px,rgba(255,255,255,0.15)_16px)]'
                  : '',
              )}
              style={{
                backgroundColor: bgColorValue,
                width: `${normalizedBuffer}%`,
                opacity: 0.3,
              }}
            />
          )}
    
          {/* Stream lines (when stream is true) */}
          {stream && !indeterminate && active && (
            <div className={cn('absolute inset-0 overflow-hidden', reverse ? 'right-0 left-auto' : 'right-auto left-0')}>
              <div
                className="animate-stream absolute inset-0 bg-[repeating-linear-gradient(90deg,transparent,transparent_10px,rgba(255,255,255,0.2)_10px,rgba(255,255,255,0.2)_20px)] bg-[length:40px_40px]"
                style={{ width: `${normalizedBuffer || 100}%` }}
              />
            </div>
          )}
    
          {/* Progress bar */}
          <div
            className={cn(
              'absolute inset-y-0 transition-colors duration-300',
              reverse ? 'right-0 left-auto' : 'right-auto left-0',
              indeterminate ? 'motion-safe:animate-indeterminate' : '',
              striped && !indeterminate
                ? 'bg-[repeating-linear-gradient(45deg,transparent,transparent_8px,rgba(255,255,255,0.25)_8px,rgba(255,255,255,0.25)_16px)]'
                : '',
            )}
            style={{
              width: indeterminate ? '100%' : `${normalizedValue}%`,
              backgroundColor: indeterminate ? undefined : progressColorValue,
            }}
          >
            {/* Indeterminate animations */}
            {indeterminate && (
              <>
                <div
                  className="motion-safe:animate-indeterminate1 absolute inset-y-0 w-full bg-inherit"
                  style={{ backgroundColor: progressColorValue }}
                />
                <div
                  className="motion-safe:animate-indeterminate2 absolute inset-y-0 w-full bg-inherit"
                  style={{ backgroundColor: progressColorValue }}
                />
              </>
            )}
          </div>
        </div>
      )
    }
    
    export { ProgressLinear }
    
  • components/ui/progress-linear/progress-linear.variants.ts1.1 kB
  • components/ui/progress-linear/index.ts0.2 kB

Raw manifest:https://uipkge.dev/r/react/progress-linear.json